package cz.cvut.fel.cs.ass.factoryMethod.store;

import java.util.ArrayList;
import java.util.List;

import cz.cvut.fel.cs.ass.factoryMethod.distributor.Distributor;
import cz.cvut.fel.cs.ass.factoryMethod.product.Order;

public abstract class Store {

	private List<Order> orderList = new ArrayList<Order>();

	private Order order = null;
	private Distributor distributor = null;

	public abstract List<Distributor> getDistributorList(); // force to override
	protected void hookProcess(Order order) {} // voluntary override

	final protected Distributor getSelectedDistributor() {
		return distributor;
	}

	final public void selectDistributor(int index) {
		distributor = getDistributorList().get(index);

	}

	final public void process(Order order) throws Exception {
		if(distributor == null) {
			throw new Exception("Select distributor");
		}
		hookProcess(order);
		
		this.order = order;
		distributor.ship(this.order);
		orderList.add(this.order);
	}

}
