package cz.cvut.fel.cs.ass.factoryMethod.store.impl;

import java.util.Arrays;
import java.util.List;

import cz.cvut.fel.cs.ass.factoryMethod.distributor.Distributor;
import cz.cvut.fel.cs.ass.factoryMethod.distributor.impl.DHL;
import cz.cvut.fel.cs.ass.factoryMethod.distributor.impl.DPD;
import cz.cvut.fel.cs.ass.factoryMethod.product.Order;
import cz.cvut.fel.cs.ass.factoryMethod.product.OrderLine;
import cz.cvut.fel.cs.ass.factoryMethod.product.Product;
import cz.cvut.fel.cs.ass.factoryMethod.product.impl.HeurecaProduct;
import cz.cvut.fel.cs.ass.factoryMethod.store.Store;

public class Heureka extends Store {

	private List<Distributor> distributorList = null;
	
	public Heureka() {
		Distributor[] distributors = { new DHL(), new DPD() };
		distributorList = Arrays.asList(distributors);
	}

	public Heureka(List<Distributor> distributorList) {
		this.distributorList = distributorList;
	}
	
	@Override
	public List<Distributor> getDistributorList() {
		return distributorList;
	}

	@Override
	protected void hookProcess(Order order) {
		System.out.println(Heureka.class.getSimpleName() + " is happy for your order");
		for (OrderLine line : order.getOrderList()) {
			Product product = line.getProduct();
			System.out.println("* " + product.getName() + " " + line.getAmount() + "x " + product.getPrice());
			if (product instanceof HeurecaProduct) {
				System.out.println("- Rank... " + ((HeurecaProduct) product).getRank());
			} else {
				System.out.println("! <Warn> not a Heureka product");
			}

		}
		System.out.println("Total: " + order.getTotal());

	}

}
