package cz.cvut.fel.cs.ass.singleton;

import java.io.WriteAbortedException;
import java.util.Set;

import cz.cvut.fel.cs.ass.singleton.impl.LoggerImpl;
import cz.cvut.fel.cs.ass.singleton.impl.PrinterImpl;
import cz.cvut.fel.cs.ass.singleton.impl.SafeFileSystem;

public class User implements Runnable {

	private String name;
	private Set<User> finishSet;

	public User(String name, Set<User> finishSet) {
		this.name = name;
		this.finishSet = finishSet;
	}

	@Override
	public void run() {
		// all try to use the same file 
		String fileName = "book.txt";
		String content = name + ".. content";
		FileSystem fs = new SafeFileSystem();
		Printer p = new PrinterImpl(fs);

		try {
			// write content
			fs.write(fileName, content);
			// put fileName to print its content
			p.enqueueFileName(fileName);
			// print one
			p.print();
			// happy finished
			finishSet.add(this);
		} catch (WriteAbortedException e) {
			new LoggerImpl().log("Error writing a file, " + e.getMessage());
		} catch (Exception e) {
			new LoggerImpl().log("Error printing, " + e.getMessage());
		}

	}

}
