package cz.cvut.fel.cs.ass.singleton.impl;
import java.util.Map.Entry;
import java.util.TreeMap;

import cz.cvut.fel.cs.ass.singleton.FileSystem;
import cz.cvut.fel.cs.ass.singleton.Printer;
import cz.cvut.fel.cs.ass.singleton.impl.util.KeyGen;

public class PrinterImpl implements Printer {

	private static int counter = 1;
	private int id;
	private FileSystem fs;
	private TreeMap<String, String> toPrint = new TreeMap<String, String>();

	public PrinterImpl(FileSystem fs) {
		id = counter++;
		this.fs = fs;
		new LoggerImpl().log(this.getClass(), id, "Init");
	}

	/* (non-Javadoc)
	 * @see cz.cvut.fel.cs.ass.Printer#enqueueFileName(java.lang.String)
	 */
	@Override
	public void enqueueFileName(String name) throws Exception {
		toPrint.put(name + KeyGen.getKey(), fs.read(name));
		new LoggerImpl().log(this.getClass(), id, "Writing to printer: " + name);
	}

	/* (non-Javadoc)
	 * @see cz.cvut.fel.cs.ass.Printer#print()
	 */
	@Override
	public void print() throws Exception {
		Entry<String,String> entry = toPrint.firstEntry();
		if(entry == null) {
			throw new Exception("print entry not found");
		}
		
		toPrint.remove(entry.getKey());
		// ..
		new LoggerImpl().log(this.getClass(), id, "Printing: " + entry.getValue());
	}

}
